# -*- encoding:utf-8 -*-
import numpy as np
from keras.models import load_model
import joblib


def read_data(path):
    lines = []
    with open(path) as f:
        for line in f.readlines()[:]:
            line = eval(line.strip())
            if line[-2][0].startswith('0') or line[-2][0].startswith('3'):
                lines.append(line)

    size = len(lines[0])
    train_x=[s[:size - 2] for s in lines]
    train_y=[s[size-1] for s in lines]
    return np.array(train_x),np.array(train_y),lines


def _score(fact, line):
    with open('dnn_predict_dmi_18d.txt', 'a') as f:
        f.write(str([line[-2], line[-1]]) + "\n")

    up_right = 0
    up_error = 0

    if fact[0] == 1:
        up_right = up_right + 1.12
    elif fact[1] == 1:
        up_right = up_right + 1.06
    elif fact[2] == 1:
        up_right = up_right + 1
    elif fact[3] == 1:
        up_right = up_right + 0.94
        up_error = up_error + 1
    else:
        up_error = up_error + 1
        up_right = up_right + 0.88
    return up_right,up_error


def predict(file_path='', model_path='15min_dnn_seq.h5', idx=-1):
    test_x,test_y,lines=read_data(file_path)
    test_x = test_x.reshape(test_x.shape[0], 1,6,77)

    model=load_model(model_path)
    score = model.evaluate(test_x, test_y)
    print('DNN', score)

    up_num = 0
    up_error = 0
    up_right = 0
    down_num = 0
    down_error = 0
    down_right = 0
    i = 0
    result=model.predict(test_x)
    win_dnn = []
    for r in result:
        fact = test_y[i]

        if idx in [-2]:
            if r[0] > 0.5 or r[1] > 0.5:
                pass
        else:
            if r[0] > 0.7 or r[1] > 0.7:
                tmp_right,tmp_error = _score(fact, lines[i])
                up_right = tmp_right + up_right
                up_error = tmp_error + up_error
                up_num = up_num + 1
            elif r[3] > 0.6 or r[4] > 0.6:
                if fact[0] == 1:
                    down_error = down_error + 1
                    down_right = down_right + 1.12
                elif fact[1] == 1:
                    down_error = down_error + 1
                    down_right = down_right + 1.06
                elif fact[2] == 1:
                    down_right = down_right + 1
                elif fact[3] == 1:
                    down_right = down_right + 0.94
                else:
                    down_right = down_right + 0.88
                down_num = down_num + 1

        i = i + 1
    if up_num == 0:
        up_num = 1
    if down_num == 0:
        down_num = 1
    print('DNN', up_right, up_num, up_right/up_num, up_error/up_num, down_right/down_num, down_error/down_num)
    return win_dnn,up_right/up_num,down_right/down_num


def multi_predict(model='14_18d'):
    r = 0;
    p = 0
    for x in range(0, 12): # 0,2,3,4,6,8,9,10,11
    # for x in [5,9,11,0,3,4,8]: #10_18,0没数据需要重新计算 [0,2,3,4,5,9,10,11]
    # for x in [0,1,10]:
    # for x in [2,4,7,10]: # 2表现最好 优秀的 0,8正确的反向指标,(9错误的反向指标 样本量太少)
        print(x)
    # for x in [0,2,5,6,7]: # 5表现最好
        win_dnn, up_ratio,down_ratio = predict(file_path='D:\\data\\quantization\\kmeans\\stock' + model + '_test_' + str(x) + '.log',
                                               model_path=model + '_dnn_seq_' + str(x) + '.h5', idx=x)
        r = r + up_ratio
        p = p + down_ratio
    print(r, p)


if __name__ == '__main__':
    predict(file_path='D:\\data\\quantization\\stock16_18d_test.log', model_path='16_18d_cnn_seq.h5')
    # predict(file_path='D:\\data\\quantization\\stock6_test.log', model_path='15m_dnn_seq.h5')
    # multi_predict(model='15_18d')
    # predict_today(20200229, model='11_18d')